/*
 * 编码器解码及初始化
 * 编码器解码在引脚中断中执行
 * 实时检测编码器,更新encodeCounter变量
 */

#include <Arduino.h>

/*
 * 变量,在中断函数中更新
 */
volatile long encodeCounterL = 0;  //左轮编码器计数
volatile long encodeCounterR = 0;  //右轮编码器计数
//引脚中断函数,负责解码编码器,更新编码器计数变量
ISR(PCINT1_vect) {
    static char oldPin = 0xff;
    char in = PINC;
    char change = in ^ oldPin;  //有改变的引脚
    char ins = in >> 1;         //右移1位,A,B相重叠
    ins ^= in;                  //同号检测
    if (change & 1) {           //如果引脚A0有变化
        if (ins & 1) {          //并且A,B不同号
            encodeCounterL--;   //编码器减1
        } else {                //如果A,B同号
            encodeCounterL++;   //编码器加1
        }
    } else if (change & (1 << 1)) {
        if (ins & 1) {
            encodeCounterL++;
        } else {
            encodeCounterL--;
        }
    }

    if (change & (1 << 2)) {
        if (ins & (1 << 2)) {
            encodeCounterR++;
        } else {
            encodeCounterR--;
        }
    } else if (change & (1 << 3)) {
        if (ins & (1 << 2)) {
            encodeCounterR--;
        } else {
            encodeCounterR++;
        }
    }
    oldPin = in;
}

void encoderSetup() {
    //配置编码器引脚
    pinMode(A0, INPUT_PULLUP);
    pinMode(A1, INPUT_PULLUP);
    pinMode(A2, INPUT_PULLUP);
    pinMode(A3, INPUT_PULLUP);
    //开启编码器引脚中断
    PCIFR = 1 << 1;
    PCMSK1 = (1 << 0) | (1 << 1) | (1 << 2) | (1 << 3);
    PCICR = 1 << 1;
}